// ##########################################################################
// ####                                                                  ####
// ####      WarpEd - A portable text editor for OS/2 Warp and Linux     ####
// ####    ===========================================================   ####
// ####                                                                  ####
// #### os2.h                                                            ####
// ####                                                                  ####
// #### Version 0.80  --  October 06, 2000                               ####
// ####                                                                  ####
// #### Copyright (C) 1996  Thomas Dreibholz                             ####
// ####               1997  Molbachweg 7                                 ####
// ####                     51674 Wiehl/Germany                          ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CRT_H
#define CRT_H


#include "../WarpEd/terminal.h"
#define INCL_VIO
#define INCL_DOSMEMMGR
#define INCL_KBD
#include <os2.h>


// #######################################################################
// ===== Farbverwaltung ==================================================
// #######################################################################


struct ColorPrefs
{
   int FrontPen;
   int BackPen;
   int Style;
   int BlockFrontPen;
   int BlockBackPen;
   int BlockStyle;
   int InfoFrontPen;
   int InfoBackPen;
   int InfoStyle;
};

#define DefaultFrontPen      10
#define DefaultBackPen       0
#define DefaultStyle         0
#define DefaultBlockFrontPen 10
#define DefaultBlockBackPen  7
#define DefaultBlockStyle    0
#define DefaultInfoFrontPen  6
#define DefaultInfoBackPen   0
#define DefaultInfoStyle     0


// #######################################################################
// ===== Tastendefinitionen ==============================================
// #######################################################################


/* 
  Tastaturdefinitionen fr OS/2 Warp:
  (Scan-Code << 8) + Char  
     + (1 << 16) fr Control
     + (1 << 17) fr Alt
*/

#define KeyControl (1 << 16)
#define KeyAlt     (1 << 17)
#define KeyShift   (1 << 18)

// #define AltSeq(c)        (((int)0x1b20 + (int)c) << 16)
#define ControlSeq(c)       ((int)c | KeyControl)
// #define ControlAltSeq(c) (((int)0x1b20 + (int)c) << 16))

#define KeyF1  0x00003b00
#define KeyF2  0x00003c00
#define KeyF3  0x00003d00
#define KeyF4  0x00003e00
#define KeyF5  0x00003f00
#define KeyF6  0x00004000
#define KeyF7  0x00004100
#define KeyF8  0x00004200
#define KeyF9  0x00004300
#define KeyF10 0x00004400
#define KeyF11 0x00008500
#define KeyF12 0x00008600
#define KeyInsert      0x000052e0
#define KeyHome        0x000047e0
#define KeyPageUp      0x000049e0
#define KeyDelete      0x000053e0
#define KeyEnd         0x00004fe0
#define KeyPageDown    0x000051e0
#define KeyCursorUp    0x000048e0
#define KeyCursorLeft  0x00004be0
#define KeyCursorDown  0x000050e0
#define KeyCursorRight 0x00004de0
#define KeyBlockHome        (0x000047e0 | KeyShift) 
#define KeyBlockPageUp      (0x000049e0 | KeyShift) 
#define KeyBlockDelete      (0x000053e0 | KeyShift) 
#define KeyBlockEnd         (0x00004fe0 | KeyShift) 
#define KeyBlockPageDown    (0x000051e0 | KeyShift) 
#define KeyBlockEnd         (0x00004fe0 | KeyShift) 
#define KeyBlockPageDown    (0x000051e0 | KeyShift) 
#define KeyBlockCursorUp    (0x000048e0 | KeyShift) 
#define KeyBlockCursorLeft  (0x00004be0 | KeyShift) 
#define KeyBlockCursorDown  (0x000050e0 | KeyShift) 
#define KeyBlockCursorRight (0x00004de0 | KeyShift) 
#define KeyBackspace        8
#define KeyShiftBackspace   (8 | KeyShift)
#define KeyReturn           13
#define KeyEscape           27
#define KeyTab              9


// #######################################################################
// ===== Terminal-Klasse =================================================
// #######################################################################


class OutputTerminalClass : public TerminalClass
{
   public:
   int        zWidth;
   int        zHeight;
   ColorPrefs zColorPrefs;
   int        zCursorX;
   int        zCursorY;
   int        zShowCursor;

   int  OpenTerminal(ColorPrefs *cprefs);
   void CloseTerminal();
   
   void Clear();
   void Bell();

   void BeginWriting();
   void EndWriting();
   void WriteLine(int x, int y, int width,
                  int offset, int m1, int m2, 
                  char       *buffer);
   void WriteString(int x, int y, int style, int frontPen, int backPen,
                    char *str);
   
   void ShowSysCursor(int x, int y);
   void HideSysCursor();
   
   int  WaitForKey(int secs, int usecs);    

   private:
   int      zWriteLevel;
   USHORT   zOldCursorX;
   USHORT   zOldCursorY;
   char    *zVideoBackup;
};
#endif
