// ##########################################################################
// ####                                                                  ####
// ####      WarpEd - A portable text editor for OS/2 Warp and Linux     ####
// ####    ===========================================================   ####
// ####                                                                  ####
// #### str.cc                                                           ####
// ####                                                                  ####
// #### Version 0.80  --  October 06, 2000                               ####
// ####                                                                  ####
// #### Copyright (C) 1996  Thomas Dreibholz                             ####
// ####               1997  Molbachweg 7                                 ####
// ####                     51674 Wiehl/Germany                          ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <string.h>
#include <bool.h>

#include "str.h"
#include "lines.h"


/* Zeichenkette optimieren */
void Optimize(char *s)
{
   int l;

   l = strlen(s);
   while((l > 0) && (s[l - 1] == ' ')) {  
      s[l - 1] = 0x00;
      l--;
   }
}


/* Zeichen einfgen */
void Insert(char chr, char *text, int index)
{
   int i,l;

   l = strlen(text);
   for(i = l + 1;i > index;i--) {
      text[i] = text[i - 1];
   }
   text[i] = chr;
}


/* Zeichen lschen */
void Delete(char *text, int index)
{
   int i,l;

   l = strlen(text);
   if(index < l) {
      for(i = index;i < l;i++) {
         text[i] = text[i + 1];
      }
      text[i]=0x00;
   }
}

/* Zeichenkette kopieren */
void Copy(char *text, int start, int end, char *dest)
{
   int i,j,l;
  
   l = strlen(text);
   j = 0;
   for(i = start;i <= end;i++)
   {
      if(i < l) {
         dest[j] = text[i];
      }
      else {
         dest[j] = ' ';
      }
      j++;
   }
   dest[j] = 0x00;
}


/* Ersetzen */
int Replace(char *text, int start, int end, char *replace)
{
   int i,j,lt,lr,gap;

   lt  = strlen(text);
   lr  = strlen(replace);
   gap = end-start;
   j   = gap+lr+lt;
//   if(j > cMaxCols) return(FALSE);
  
   for(i = start;i < lt - gap;i++) {
      text[i] = text[i + gap];
   }
   text[i] = 0x00;
  
   text[lt + lr + 1] = 0x00;
   for(i = lt + lr;i >= end;i--) {
      text[i] = text[i - lr];
   }
  
   for(j = 0;j < lr;j++) {
      text[j + start] = replace[j];
   }
  
   return(TRUE);
}

